import 'dart:convert' as convert;
import 'dart:convert';
import 'package:flutter/material.dart';
import 'package:http/http.dart' as http;
import 'package:uema_iduema/src/login/login-model.dart';
import 'dart:io';

import 'package:uema_iduema/src/usuario/usuario-model.dart';
import 'package:uema_iduema/src/usuario/usuario-service.dart';

import '../dio.dart';

Future<UrlFoto> urlFoto() async {
  UsuarioModel user = new UsuarioModel();
  LoginModel loginModel = new LoginModel();
  final response = await http.get(
      'https://sis.sig.uema.br/sigaa/resgatarFotoUsuario?cpf=${user.cpf.toString()}');

  print(loginModel.login);

  if (response.statusCode == 200) {
    // If the server did return a 200 OK response,
    // then parse the JSON.
    print('Resgata imagem' + response.statusCode.toString());
    print(response.body);
    print(UrlFoto.fromJson(jsonDecode(response.body)));
    return UrlFoto.fromJson(jsonDecode(response.body));
  } else {
    // If the server did not return a 200 OK response,
    // then throw an exception.
    throw Exception('Failed to load album');
  }
}

Future<UrlFoto> retornoInfo(String dado) async {
  UsuarioModel user = new UsuarioModel();
  String url = "https://sis.sig.uema.br/sigaa/resgatarFotoUsuario?cpf=${dado}";
  print(dado);
  var dio = CustomDio.withAuthentication().instance;
  UrlFoto urlFoto = new UrlFoto();

  return dio.get(url).then((res) {
    print(res.toString());
    urlFoto = UrlFoto.fromJson(res.data);
    print(res.data);
    return urlFoto;
  });
}

class UrlFoto {
  final String url;

  UrlFoto({@required this.url});

  factory UrlFoto.fromJson(Map<String, dynamic> json) {
    return UrlFoto(url: json['url']);
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['url'] = this.url;
    return data;
  }
}

class ImagemService extends StatefulWidget {
  final String dado;

  const ImagemService({Key key, this.dado}) : super(key: key);
  String get _dado {
    return dado;
  }

  @override
  _ImagemServiceState createState() => _ImagemServiceState();
}

class _ImagemServiceState extends State<ImagemService> {
  UsuarioService userService = new UsuarioService();
  UsuarioModel user = new UsuarioModel();
  Future<UrlFoto> pegarFoto;

  @override
  void initState() {
    //retornoInfo();
    pegarFoto = urlFoto();
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return FutureBuilder(
        future: pegarFoto,
        builder: (context, snapshot) {
          if (snapshot.hasError) {
            return Center(
              child: Column(
                crossAxisAlignment: CrossAxisAlignment.center,
                children: [
                  Icon(
                    Icons.face_outlined,
                    size: 100,
                  ),
                  Text(
                    'Sem foto!',
                    style: TextStyle(fontSize: 25),
                  )
                ],
              ),
            );
          } else if (snapshot.hasData) {
            return Container(
              height: MediaQuery.of(context).size.height * 0.255,
              width: MediaQuery.of(context).size.width * 0.35,
              child: Text(
                'https://sis.sig.uema.br/' + snapshot.data.url.toString(),
              ),
            );
          } else {
            return CircularProgressIndicator();
          }
        });
  }
}
